from app import app, isAnAdmin
from pyrogram import filters
from pyrogram.types import ChatPrivileges
from modules.utils import should_quote, find_user, configGet
from classes.holo_user import HoloUser

@app.on_message(~ filters.scheduled & filters.private & filters.command(["label"], prefixes=["/"]))
async def cmd_label(app, msg):

    if msg.chat.id == configGet("admin_group") or await isAnAdmin(msg.from_user.id):

        if len(msg.command) < 3:
            await msg.reply_text("Invalid syntax:\n`/label USER NICKNAME`")
            return

        target = await find_user(app, msg.command[1])

        if target is not None:
            
            target = HoloUser(target)

            nickname = " ".join(msg.command[2:])

            if nickname.lower() == "reset":
                await target.reset_label(app, msg.chat)
                await msg.reply_text(f"Resetting **{target.id}**'s label...", quote=should_quote(msg))
                
            else:
                await target.set_label(app, msg.chat, nickname)
                await msg.reply_text(f"Setting **{target.id}**'s label to **{nickname}**...", quote=should_quote(msg))
                
        else:
            await msg.reply_text(f"User not found")